package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.jhgk.excel.QfExcel;
import com.dsic.gj_erp.mapper.jcsj.EmGcrlMapper;
import com.dsic.gj_erp.mapper.jhgk.DmQfxqMapper;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import com.dsic.gj_erp.service.jhgk.DmYdjhService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-09-18
 */
@Service
public class DmQfxqServiceImpl extends ServiceImpl<DmQfxqMapper, DmQfxq> implements DmQfxqService {


    @Resource
    private EmGcrlMapper gcrlMapper;

    @Resource
    private DmYdjhService ydjhService;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ResultBean uploadQf(List<QfExcel> list, String project, HttpServletRequest req) {
        List<DmQfxq> listForSave = new ArrayList<>();
        for (QfExcel q : list) {
            DmQfxq a = new DmQfxq();
            BeanUtil.copyProperties(q, a);
            String pl = a.getDcPl().length() == 1 ? "00" + a.getDcPl() : a.getDcPl().length() == 2 ? "0" + a.getDcPl() : a.getDcPl();
            a.setDcPl(pl);
            a.setBzry((String) req.getAttribute("yhms"));
            a.setBzrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd"));
            listForSave.add(a);
            this.remove(new QueryWrapper<DmQfxq>().eq("Dc_ch", a.getDcCh()).eq("Dc_pl", a.getDcPl()).eq("Dc_fd", a.getDcFd()));
        }
        this.saveBatch(listForSave);
        //生成月度计划信息
        generateYdjh(listForSave);
        return new ResultBean();
    }

    /**
     * 生成月度计划
     *
     * @param list
     */
    public void generateYdjh(List<DmQfxq> list) {
        //分段
        List<String> ids = list.stream().map(DmQfxq::getId).collect(Collectors.toList());
        //获取对应的 三月滚动计划明细
        //需要再次排产？目前没排
        List<DmYdjh> ydjhList = baseMapper.getYdjh(ids);
        if (ydjhList.size() < 1) {
            System.out.println("当前导入的前方需求没有对应的三月滚动计划！");
        }
        for (DmYdjh dmYdjh : ydjhList) {
            ydjhService.remove(new QueryWrapper<DmYdjh>()
                    .eq("Dc_Ch",dmYdjh.getDcCh())
                    .eq("Dc_Pl",dmYdjh.getDcPl())
                    .eq("Tzbh",dmYdjh.getTzbh()));
            ydjhService.save(dmYdjh);
        }
    }

}
